git-stash.shon commit git svn info: tests: use test_cmp instead of git-diff (67214c8)
   1#!/bin/sh
   2# Copyright (c) 2007, Nanako Shiraishi
   3
   4dashless=$(basename "$0" | sed -e 's/-/ /')
   5USAGE="list [<options>]
   6   or: $dashless (show | drop | pop ) [<stash>]
   7   or: $dashless apply [--index] [<stash>]
   8   or: $dashless branch <branchname> [<stash>]
   9   or: $dashless [save [--keep-index] [<message>]]
  10   or: $dashless clear"
  11
  12SUBDIRECTORY_OK=Yes
  13OPTIONS_SPEC=
  14. git-sh-setup
  15require_work_tree
  16cd_to_toplevel
  17
  18TMP="$GIT_DIR/.git-stash.$$"
  19trap 'rm -f "$TMP-*"' 0
  20
  21ref_stash=refs/stash
  22
  23no_changes () {
  24        git diff-index --quiet --cached HEAD --ignore-submodules -- &&
  25        git diff-files --quiet --ignore-submodules
  26}
  27
  28clear_stash () {
  29        if test $# != 0
  30        then
  31                die "git stash clear with parameters is unimplemented"
  32        fi
  33        if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
  34        then
  35                git update-ref -d $ref_stash $current
  36        fi
  37}
  38
  39create_stash () {
  40        stash_msg="$1"
  41
  42        if no_changes
  43        then
  44                exit 0
  45        fi
  46
  47        # state of the base commit
  48        if b_commit=$(git rev-parse --verify HEAD)
  49        then
  50                head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
  51        else
  52                die "You do not have the initial commit yet"
  53        fi
  54
  55        if branch=$(git symbolic-ref -q HEAD)
  56        then
  57                branch=${branch#refs/heads/}
  58        else
  59                branch='(no branch)'
  60        fi
  61        msg=$(printf '%s: %s' "$branch" "$head")
  62
  63        # state of the index
  64        i_tree=$(git write-tree) &&
  65        i_commit=$(printf 'index on %s\n' "$msg" |
  66                git commit-tree $i_tree -p $b_commit) ||
  67                die "Cannot save the current index state"
  68
  69        # state of the working tree
  70        w_tree=$( (
  71                rm -f "$TMP-index" &&
  72                cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
  73                GIT_INDEX_FILE="$TMP-index" &&
  74                export GIT_INDEX_FILE &&
  75                git read-tree -m $i_tree &&
  76                git add -u &&
  77                git write-tree &&
  78                rm -f "$TMP-index"
  79        ) ) ||
  80                die "Cannot save the current worktree state"
  81
  82        # create the stash
  83        if test -z "$stash_msg"
  84        then
  85                stash_msg=$(printf 'WIP on %s' "$msg")
  86        else
  87                stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
  88        fi
  89        w_commit=$(printf '%s\n' "$stash_msg" |
  90                git commit-tree $w_tree -p $b_commit -p $i_commit) ||
  91                die "Cannot record working tree state"
  92}
  93
  94save_stash () {
  95        keep_index=
  96        case "$1" in
  97        --keep-index)
  98                keep_index=t
  99                shift
 100        esac
 101
 102        stash_msg="$*"
 103
 104        if no_changes
 105        then
 106                echo 'No local changes to save'
 107                exit 0
 108        fi
 109        test -f "$GIT_DIR/logs/$ref_stash" ||
 110                clear_stash || die "Cannot initialize stash"
 111
 112        create_stash "$stash_msg"
 113
 114        # Make sure the reflog for stash is kept.
 115        : >>"$GIT_DIR/logs/$ref_stash"
 116
 117        git update-ref -m "$stash_msg" $ref_stash $w_commit ||
 118                die "Cannot save the current status"
 119        printf 'Saved working directory and index state "%s"\n' "$stash_msg"
 120
 121        git reset --hard
 122
 123        if test -n "$keep_index" && test -n $i_tree
 124        then
 125                git read-tree --reset -u $i_tree
 126        fi
 127}
 128
 129have_stash () {
 130        git rev-parse --verify $ref_stash >/dev/null 2>&1
 131}
 132
 133list_stash () {
 134        have_stash || return 0
 135        git log --no-color --pretty=oneline -g "$@" $ref_stash -- |
 136        sed -n -e 's/^[.0-9a-f]* refs\///p'
 137}
 138
 139show_stash () {
 140        flags=$(git rev-parse --no-revs --flags "$@")
 141        if test -z "$flags"
 142        then
 143                flags=--stat
 144        fi
 145        s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
 146
 147        w_commit=$(git rev-parse --verify "$s") &&
 148        b_commit=$(git rev-parse --verify "$s^") &&
 149        git diff $flags $b_commit $w_commit
 150}
 151
 152apply_stash () {
 153        git diff-files --quiet --ignore-submodules ||
 154                die 'Cannot restore on top of a dirty state'
 155
 156        unstash_index=
 157        case "$1" in
 158        --index)
 159                unstash_index=t
 160                shift
 161        esac
 162
 163        # current index state
 164        c_tree=$(git write-tree) ||
 165                die 'Cannot apply a stash in the middle of a merge'
 166
 167        # stash records the work tree, and is a merge between the
 168        # base commit (first parent) and the index tree (second parent).
 169        s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
 170        w_tree=$(git rev-parse --verify "$s:") &&
 171        b_tree=$(git rev-parse --verify "$s^1:") &&
 172        i_tree=$(git rev-parse --verify "$s^2:") ||
 173                die "$*: no valid stashed state found"
 174
 175        unstashed_index_tree=
 176        if test -n "$unstash_index" && test "$b_tree" != "$i_tree" &&
 177                        test "$c_tree" != "$i_tree"
 178        then
 179                git diff-tree --binary $s^2^..$s^2 | git apply --cached
 180                test $? -ne 0 &&
 181                        die 'Conflicts in index. Try without --index.'
 182                unstashed_index_tree=$(git-write-tree) ||
 183                        die 'Could not save index tree'
 184                git reset
 185        fi
 186
 187        eval "
 188                GITHEAD_$w_tree='Stashed changes' &&
 189                GITHEAD_$c_tree='Updated upstream' &&
 190                GITHEAD_$b_tree='Version stash was based on' &&
 191                export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
 192        "
 193
 194        if git-merge-recursive $b_tree -- $c_tree $w_tree
 195        then
 196                # No conflict
 197                if test -n "$unstashed_index_tree"
 198                then
 199                        git read-tree "$unstashed_index_tree"
 200                else
 201                        a="$TMP-added" &&
 202                        git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
 203                        git read-tree --reset $c_tree &&
 204                        git update-index --add --stdin <"$a" ||
 205                                die "Cannot unstage modified files"
 206                        rm -f "$a"
 207                fi
 208                git status || :
 209        else
 210                # Merge conflict; keep the exit status from merge-recursive
 211                status=$?
 212                if test -n "$unstash_index"
 213                then
 214                        echo >&2 'Index was not unstashed.'
 215                fi
 216                exit $status
 217        fi
 218}
 219
 220drop_stash () {
 221        have_stash || die 'No stash entries to drop'
 222
 223        if test $# = 0
 224        then
 225                set x "$ref_stash@{0}"
 226                shift
 227        fi
 228        # Verify supplied argument looks like a stash entry
 229        s=$(git rev-parse --revs-only --no-flags "$@") &&
 230        git rev-parse --verify "$s:"   > /dev/null 2>&1 &&
 231        git rev-parse --verify "$s^1:" > /dev/null 2>&1 &&
 232        git rev-parse --verify "$s^2:" > /dev/null 2>&1 ||
 233                die "$*: not a valid stashed state"
 234
 235        git reflog delete --updateref --rewrite "$@" &&
 236                echo "Dropped $* ($s)" || die "$*: Could not drop stash entry"
 237
 238        # clear_stash if we just dropped the last stash entry
 239        git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
 240}
 241
 242apply_to_branch () {
 243        have_stash || die 'Nothing to apply'
 244
 245        test -n "$1" || die 'No branch name specified'
 246        branch=$1
 247
 248        if test -z "$2"
 249        then
 250                set x "$ref_stash@{0}"
 251        fi
 252        stash=$2
 253
 254        git-checkout -b $branch $stash^ &&
 255        apply_stash --index $stash &&
 256        drop_stash $stash
 257}
 258
 259# Main command set
 260case "$1" in
 261list)
 262        shift
 263        if test $# = 0
 264        then
 265                set x -n 10
 266                shift
 267        fi
 268        list_stash "$@"
 269        ;;
 270show)
 271        shift
 272        show_stash "$@"
 273        ;;
 274save)
 275        shift
 276        save_stash "$@"
 277        ;;
 278apply)
 279        shift
 280        apply_stash "$@"
 281        ;;
 282clear)
 283        shift
 284        clear_stash "$@"
 285        ;;
 286create)
 287        if test $# -gt 0 && test "$1" = create
 288        then
 289                shift
 290        fi
 291        create_stash "$*" && echo "$w_commit"
 292        ;;
 293drop)
 294        shift
 295        drop_stash "$@"
 296        ;;
 297pop)
 298        shift
 299        if apply_stash "$@"
 300        then
 301                test -z "$unstash_index" || shift
 302                drop_stash "$@"
 303        fi
 304        ;;
 305branch)
 306        shift
 307        apply_to_branch "$@"
 308        ;;
 309*)
 310        if test $# -eq 0
 311        then
 312                save_stash &&
 313                echo '(To restore them type "git stash apply")'
 314        else
 315                usage
 316        fi
 317        ;;
 318esac